<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>SASLAuthenticationProvider.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server.auth</a> &gt; <span class="el_source">SASLAuthenticationProvider.java</span></div><h1>SASLAuthenticationProvider.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper.server.auth;

import org.apache.zookeeper.KeeperException;
import org.apache.zookeeper.server.ServerCnxn;

<span class="fc" id="L24">public class SASLAuthenticationProvider implements AuthenticationProvider {</span>

    public String getScheme() {
<span class="fc" id="L27">        return &quot;sasl&quot;;</span>
    }

    public KeeperException.Code
        handleAuthentication(ServerCnxn cnxn, byte[] authData)
    {
        // Should never call this: SASL authentication is negotiated at session initiation.
        // TODO: consider substituting current implementation of direct ClientCnxn manipulation with
        // a call to this method (SASLAuthenticationProvider:handleAuthentication()) at session initiation.
<span class="nc" id="L36">        return KeeperException.Code.AUTHFAILED;</span>

    }

    public boolean matches(String id,String aclExpr) {
<span class="nc bnc" id="L41" title="All 2 branches missed.">        if (System.getProperty(&quot;zookeeper.superUser&quot;) != null) {</span>
<span class="nc bnc" id="L42" title="All 4 branches missed.">            return (id.equals(System.getProperty(&quot;zookeeper.superUser&quot;)) || id.equals(aclExpr));</span>
        }
<span class="nc bnc" id="L44" title="All 4 branches missed.">        return (id.equals(&quot;super&quot;) || id.equals(aclExpr));</span>
    }

    public boolean isAuthenticated() {
<span class="fc" id="L48">        return true;</span>
    }

    public boolean isValid(String id) {
        // Since the SASL authenticator will usually be used with Kerberos authentication,
        // it should enforce that these names are valid according to Kerberos's
        // syntax for principals.
        //
        // Use the KerberosName(id) constructor to define validity:
        // if KerberosName(id) throws IllegalArgumentException, then id is invalid.
        // otherwise, it is valid.
        //
        try {
<span class="fc" id="L61">            new KerberosName(id);</span>
<span class="fc" id="L62">            return true;</span>
        }
<span class="fc" id="L64">        catch (IllegalArgumentException e) {</span>
<span class="fc" id="L65">            return false;</span>
        }
   }


}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>